﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using System.Drawing.Design;

namespace designer
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            addComponent (typeof (Button));
            addComponent (typeof (TreeView));
            addComponent (typeof (Panel));
            addComponent (typeof (DataGrid));

            addColor ("red");
            addColor ("cornflowerblue");
            addColor ("lime");
            addColor ("yellow");
        }

        public void addComponent (Type type)
        {
            // using System.Drawing.Design;
            ToolboxItem item = new ToolboxItem (type);

            ToolStripButton btn = new ToolStripButton ();
            btn.Image = item.Bitmap;
            btn.ToolTipText = item.DisplayName;
            btn.Tag = item;
            btn.Click += componentClick;
            componentPalette.Items.Add (btn);
        }

        public void addColor (Color color)
        {
            const int size = 32;
            Bitmap img = new Bitmap (size, size);
            Graphics g = Graphics.FromImage (img);
            g.FillEllipse (new SolidBrush (color), 1, 1, size-2, size-2);

            ToolStripButton btn = new ToolStripButton ();
            btn.Image = img;
            btn.ToolTipText = color.Name;
            btn.Tag = color;
            colorPalette.Items.Add (btn);
        }

        public void addColor (string name)
        {
            addColor (Color.FromName (name));
        }

        private void componentClick (object sender, EventArgs e)
        {
            ToolboxItem item = (sender as ToolStripButton).Tag as ToolboxItem;
            IComponent [] comp_list = item.CreateComponents ();
            Control comp = comp_list[0] as Control;
            area.Controls.Add (comp);
        }
    }

    // Tools > Options > Text Editor > C# > CodeStyle > Formatting > Spacing
}
